package io.renren.modules.sys.controller;

import com.alibaba.fastjson.JSON;
import io.renren.common.annotation.LogOperation;
import io.renren.common.constant.Constant;
import io.renren.common.page.PageData;
import io.renren.common.utils.ExcelUtils;
import io.renren.common.utils.Result;
import io.renren.common.validator.AssertUtils;
import io.renren.common.validator.ValidatorUtils;
import io.renren.common.validator.group.AddGroup;
import io.renren.common.validator.group.DefaultGroup;
import io.renren.common.validator.group.UpdateGroup;
import io.renren.modules.security.controller.AbstractController;
import io.renren.modules.sys.dto.AdvertOauthDTO;
import io.renren.modules.sys.excel.AdvertOauthExcel;
import io.renren.modules.sys.service.AdvertOauthService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import springfox.documentation.annotations.ApiIgnore;

import javax.servlet.http.HttpServletResponse;
import java.util.Date;
import java.util.List;
import java.util.Map;


/**
 * 广告平台授权
 *
 * @author Mark sunlightcs@gmail.com
 * @since 1.0.0 2022-05-30
 */
@RestController
@RequestMapping("sys/advertoauth")
@Api(tags="广告平台授权")
@Slf4j
public class AdvertOauthController extends AbstractController {
    @Autowired
    private AdvertOauthService advertOauthService;

    @GetMapping("page")
    @ApiOperation("分页")
    @ApiImplicitParams({
        @ApiImplicitParam(name = Constant.PAGE, value = "当前页码，从1开始", paramType = "query", required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.LIMIT, value = "每页显示记录数", paramType = "query",required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.ORDER_FIELD, value = "排序字段", paramType = "query", dataType="String") ,
        @ApiImplicitParam(name = Constant.ORDER, value = "排序方式，可选值(asc、desc)", paramType = "query", dataType="String")
    })
    @RequiresPermissions("sys:advertoauth:page")
    public Result<PageData<AdvertOauthDTO>> page(@ApiIgnore @RequestParam Map<String, Object> params){
        PageData<AdvertOauthDTO> page = advertOauthService.page(params);

        return new Result<PageData<AdvertOauthDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @ApiOperation("信息")
    @RequiresPermissions("sys:advertoauth:info")
    public Result<AdvertOauthDTO> get(@PathVariable("id") Long id){
        AdvertOauthDTO data = advertOauthService.get(id);

        return new Result<AdvertOauthDTO>().ok(data);
    }

    @PostMapping
    @ApiOperation("保存")
    @LogOperation("保存")
    @RequiresPermissions("sys:advertoauth:save")
    public Result save(@RequestBody AdvertOauthDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);

        dto.setCreatedBy(getUserId());
        dto.setCreateTime(new Date());
        dto.setUpdatedBy(getUserId());
        dto.setUpdateTime(new Date());
        String url = advertOauthService.saveOauth(dto);

        return new Result().ok(url);
    }

    @PutMapping
    @ApiOperation("修改")
    @LogOperation("修改")
    @RequiresPermissions("sys:advertoauth:update")
    public Result update(@RequestBody AdvertOauthDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);

        dto.setUpdatedBy(getUserId());
        dto.setUpdateTime(new Date());
        String url = advertOauthService.updateOauth(dto);

        return new Result().ok(url);
    }

    @DeleteMapping
    @ApiOperation("删除")
    @LogOperation("删除")
    @RequiresPermissions("sys:advertoauth:delete")
    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");
        for (Long id:ids){
            AdvertOauthDTO dto = advertOauthService.get(id);
            dto.setDeleteTime(new Date());
            dto.setUpdatedBy(this.getUserId());
            advertOauthService.update(dto);
        }
        return new Result();
    }

    @GetMapping("export")
    @ApiOperation("导出")
    @LogOperation("导出")
    @RequiresPermissions("sys:advertoauth:export")
    public void export(@ApiIgnore @RequestParam Map<String, Object> params, HttpServletResponse response) throws Exception {
        List<AdvertOauthDTO> list = advertOauthService.list(params);

        ExcelUtils.exportExcelToTarget(response, null, list, AdvertOauthExcel.class);
    }

    /**
     * 授权
     * @param id
     * @return
     */
    @GetMapping("grant")
    @RequiresPermissions("sys:advertoauth:grant")
    public Result<String> grant(Long id) {
        AdvertOauthDTO advertOauth = advertOauthService.get(id);
        advertOauth.setUpdatedBy(getUserId());
        advertOauth.setUpdateTime(new Date());
        String url = advertOauthService.grantOauth(advertOauth);
        return new Result<String>().ok(url);
    }

    /**
     * 取消授权
     * @param id
     * @return
     */
    @GetMapping("cancel")
    @RequiresPermissions("sys:advertoauth:cancel")
    public Result<?> cancel(Long id) {
        AdvertOauthDTO advertOauth = advertOauthService.get(id);
        advertOauth.setUpdatedBy(getUserId());
        advertOauth.setUpdateTime(new Date());
        advertOauthService.cancelOauth(advertOauth);
        return new Result();
    }

    /**
     *
     * @param paramMap 获取token入参  state：授权主键  auth_code
     * @return
     */
    @GetMapping("getToken")
    public Result<?> getToken(@RequestParam Map<String,Object> paramMap) {
        log.info("回调获取token接口传入参数paramMap={}", JSON.toJSONString(paramMap));
        advertOauthService.getToken(paramMap);
        return new Result();
    }

}